<?php

namespace Addons\PHPEmail;
use Common\Controller\Addon;


/**
 * 邮件插件
 * @author ranmoon
 */

    class PHPEmailAddon extends Addon{

        public $info = array(
            'name'=>'PHPEmail',
            'title'=>'邮件',
            'description'=>'基于PHPMailer开发的一个插件',
            'status'=>1,
            'author'=>'ranmoon',
            'version'=>'1.0'
        );

        public function install(){

            //增加钩子,如果不想使用, 请自行创建
            $where = ['name'=>'sendEmail'];
            $result = M('hooks')->where($where)->find();
            if(!$result){
                $insertDatas = [
                    'name'        => 'sendEmail',
                    'description' => '基于PHPMailer发邮件',
                    'type'        => 1,
                    'update_time' => time(),
                    'status'      => 1,
                    'addon'       => 'PHPEmail',
                ];
            }

            $hook = M('hooks')->add($insertDatas);
            if($hook){
                return true;
            }else{
                $this->error('创建钩子失败,请检查错误或者手动安装!');
            }
            return true; // 手动安装注释掉上面的代码
        }

        public function uninstall(){

            //删除钩子
            $where = ['name'=>'sendEmail'];
            $result = M('hooks')->where($where)->find();
            if($result){
                $hook = M('hooks')->where($where)->delete();
               /* if(!$hook){
                    $this->error('false');
                }*/
            }

            return true;
        }

        /**
         * 发送邮件
         *
         * @return true || error
         */
         public function sendEmail($param){
            return $this->send_email($param['email'],$param['subject'],$param['content'],$param['sender']);
        }

        /**
         * ///发送邮件,在这里我只用到我常用的,如需要其它功能自行增加///
         * @param $email 设置接收人, 可多个==> '123@qq.com,234@qq.com'
         * @param $subject 邮箱主题 string emial title
         * @param $content 内容 string emial title
         * @param $sender 设置发件人名称 string 'onethink插件'
         * @param debug=0 测试模式
         * @return  true || error
         */

        private function send_email($email='', $subject='',$content='',$sender='',$debug=0){
            $config = $this->getConfig();
            require ONETHINK_ADDON_PATH.'PHPEmail/PHPMailer/PHPMailerAutoload.php';
            $mail = new \PHPMailer();
            $mail->SMTPDebug = $debug;                               // Enable verbose debug output
            $mail->isSMTP();                                      // Set mailer to use SMTP
            $mail->Host = $config['Host'];  // Specify main and backup SMTP servers
            $mail->SMTPAuth = true;                               // Enable SMTP authentication
            $mail->Username = $config['Username'];                 // SMTP username
            $mail->Password = $config['Password'];                           // SMTP password
            $mail->SMTPSecure = 'tls';                            // Enable TLS encryption, `ssl` also accepted
            $mail->Port = $config['Port'];                                    // TCP port to connect to

            $mail->setFrom($config['Username'], $sender);
            //$mail->addAddress('xxx@qq.com', 'Joe User');     // Add a recipient
            $toEmail = explode(',',$email);
            foreach($toEmail as $val){
                $mail->addAddress($val);     // Add a recipient
            }
            //$mail->addReplyTo($config['Username'], $fromName);
            //$mail->addCC('cc@example.com');
            //$mail->addBCC('bcc@example.com');

            //$mail->addAttachment('/var/tmp/file.tar.gz');         // Add attachments
            //$mail->addAttachment('/tmp/image.jpg', 'new.jpg');    // Optional name
            $mail->isHTML(true);                                  // Set email format to HTML

            $mail->Subject = $subject;
            $mail->Body    = $content; //html 内容
            $mail->AltBody = $content; // 非html 内容

            if(!$mail->send()) {
                //echo 'Message could not be sent.';
                return 'Mailer Error: ' . $mail->ErrorInfo;
            } else {
//                echo 'Message has been sent';
                return true;
            }
        }
    }